unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ShellApi, Compress;

type
  TFrameForm = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    RichEdit1: TRichEdit;
    RichEdit2: TRichEdit;
    Label4: TLabel;
    Label5: TLabel;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Button6: TButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    Huffman: THuffman;
    SlideDic: TSlideDic;
    Compress: TCompress;
    Archiver: TArchiver;
    MTime: Cardinal; // GR[hɗv~bPʂ̎
    STime: String; // MTime 𕶎ŕ\
    SLabel4: String;
    SLabel4LZ: String;
    SLabel5: String;
    SLabel5LZ: String;
    function CheckHuffman: Boolean;
    function CheckSlideDic: Boolean;
    function CheckCompress: Boolean;
    function Percent(X, Y: Int64): String;
    procedure MakeSTime;
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

function TFrameForm.Percent(X, Y: Int64): String;
begin
  Result := '';
  if Y = 0 then
  begin
    if X = 0 then
      Result := '100.0'
    else
      Result := '';
    Exit;
  end;
  X := X * 10000 div Y;
  if X mod 10 >= 5 then
    X := X + 10;
  Y := X div 100; // 2 ̒l
  X := (X mod 100) div 10; // 1 ̒l
  Result := IntToStr(Y) + '.' + IntToStr(X);
end;
procedure TFrameForm.MakeSTime;
var
  h, m, s, ms: Cardinal;
  ss: Extended;
begin
  STime := '0.000 b';
  if MTime = 0 then
    Exit;

  ms := MTime; // 1 ~bPʂ̒l
  s := ms div 1000; // 1 bPʂ̒l

  h := s div (60 * 60); // 
  m := (s mod (60 * 60)) div 60; // 
  s := s mod 60; // b
  ms := ms mod 1000; // ~b

  ss := (s * 1000 + ms) / 1000; // lƂĂ̕b

  STime := Format('%5.3f b', [ss]);
  if m <> 0 then
    STime := IntToStr(m) + '  ' + STime;
  if h <> 0 then
    STime := IntToStr(h) + '  ' + STime;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  Archiver.Free;
  Compress.Free;
  SlideDic.Free;
  Huffman.Free;
end;

procedure TFrameForm.Button1Click(Sender: TObject);
var
  FileName: String;
  Rate: String;
  Dir: String;
begin
  Label4.Caption := SLabel4;
  Label5.Caption := SLabel5;
  Dir := ExtractFilePath(Application.ExeName) + 'Data';

  if OpenDialog1.Execute then
  begin
    Huffman.InStream.LoadFromFile(OpenDialog1.FileName);
    Huffman.Encode; // nt}ŃGR[hB
    STime := Huffman.STime;
    RichEdit1.Lines.Text := Huffman.OldNodes;
    RichEdit2.Lines.Text := Huffman.NewNodes;

    Edit1.Text := OpenDialog1.FileName;
    Label1.Caption := '1) Ώۃt@C : ' +
                      IntToStr(Huffman.InStream.Size) + ' oCg';

    FileName := Dir + '\' + ExtractFileName(OpenDialog1.FileName);
    FileName := ChangeFileExt(FileName,'.enc');
    Huffman.OutStream.SaveToFile(FileName);

    Rate := Percent(Huffman.OutStream.Size, Huffman.InStream.Size);

    Edit2.Text := FileName;
    Label2.Caption := '2) 1) GR[h (  ) t@C : ' +
                      IntToStr(Huffman.OutStream.Size) +
                      ' oCg ( k : ' + Rate + ' % )';

    Huffman.InStream.LoadFromFile(FileName);
    Huffman.Decode;
    STime := Copy(Stime, 1, 5) + ' + ' + Huffman.STime;

    FileName := ChangeFileExt(FileName,'.dec');
    Huffman.OutStream.SaveToFile(FileName);

    Edit3.Text := FileName;
    Label3.Caption := '3) 2) fR[h (  ) t@C : ' + IntToStr(Huffman.OutStream.Size) + ' oCg';

    if CheckHuffman = True then
      ShowMessage('   GR[hтɃfR[h͐܂B   ' + #13#10 + #13#10 +
                  '   Ώۃt@CƃfR[ht@C͓ełB   ' + #13#10 + #13#10 +
                  '   k ' + Rate + ' % łB   ' + #13#10 + #13#10 +
                  '   GR[h + fR[hԂ ' + STime + '  łB   ')
    else
      ShowMessage('   GR[hyуfR[h͎s܂B   ');
  end;
end;

procedure TFrameForm.FormShow(Sender: TObject);
begin
  Huffman := THuffman.Create;
  Huffman.Debug := True;
  Huffman.StopOption := True;
  SlideDic := TSlideDic.Create;
  SlideDic.DicSize := 1024 * 64; // 1024 ` 1024 * 64
  SlideDic.MatchSize := 256; // 8 ` 256
  SlideDic.StopOption := 95; // 0 ` 100
  SlideDic.LateRating := 1; // 0 ` 3
  SlideDic.Hash := 0;
  SlideDic.HashCount := 256; // 0 ` 256
  Compress := TCompress.Create;
  Compress.BlockSize := 1024 * 64;
  Compress.Huffman.Debug := True;
  Compress.Huffman.StopOption := True;
  Compress.SlideDic.DicSize := 1024 * 64; // 1024 ` 1024 * 64
  Compress.SlideDic.MatchSize := 256; // 8 ` 256
  Compress.SlideDic.StopOption := 95; // 0 ` 100
  Compress.SlideDic.LateRating := 1; // 0 ` 3
  Compress.SlideDic.Hash := 0;
  Compress.SlideDic.HashCount := 256; // 0 ` 256
  Archiver := TArchiver.Create;
  Archiver.Compress.BlockSize := 1024 * 64;
  Archiver.Compress.Huffman.StopOption := True;
  Archiver.Compress.Huffman.Debug := True;
  Archiver.Compress.SlideDic.DicSize := 1024 * 64; // 1024 ` 1024 * 64
  Archiver.Compress.SlideDic.MatchSize := 256; // 8 ` 256
  Archiver.Compress.SlideDic.StopOption := 95; // 0 ` 100
  Archiver.Compress.SlideDic.LateRating := 1; // 0 ` 3
  Archiver.Compress.SlideDic.Hash := 0;
  Archiver.Compress.SlideDic.HashCount := 256; // 0 ` 256
  SLabel4 := Label4.Caption;
  SLabel4LZ := 'LZ77 ̈vf[^̈ṽnt}zƊ֘Az';
  SLabel5 := Label5.Caption;
  SLabel5LZ := 'LZ77 ̈vf[^̈vʒũrbg̃nt}zƊ֘Az';
end;

function TFrameForm.CheckHuffman: Boolean;
var
  PI, PO: PChar;
  i, CS: Integer;
begin
  Result := False;
  Huffman.InStream.LoadFromFile(OpenDialog1.FileName);
  if Huffman.InStream.Size <> Huffman.OutStream.Size then
    Exit;

  PI := Huffman.InStream.Memory;
  PO := Huffman.OutStream.Memory;

  Result := True;
  CS := Huffman.InStream.Size;
  if CS > 1024 * 128 then
    CS := 1024 * 128; // ȏׂ͒ȂB
  for i := 0 to CS - 1 do
  begin
    if PI[i] <> PO[i] then
    begin
      Result := False;
      Break;
    end;
  end;
end;

function TFrameForm.CheckSlideDic: Boolean;
var
  PI, PO: PChar;
  i, CS: Integer;
begin
  Result := False;
  SlideDic.InStream.LoadFromFile(OpenDialog1.FileName);
  if SlideDic.InStream.Size <> SlideDic.OutStream.Size then
    Exit;

  PI := SlideDic.InStream.Memory;
  PO := SlideDic.OutStream.Memory;

  Result := True;
  CS := SlideDic.InStream.Size;
  if CS > 1024 * 128 then
    CS := 1024 * 128; // ȏׂ͒ȂB
  for i := 0 to CS - 1 do
  begin
    if PI[i] <> PO[i] then
    begin
      Result := False;
      Break;
    end;
  end;
end;

function TFrameForm.CheckCompress: Boolean;
var
  PI, PO: PChar;
  i, CS: Integer;
begin
  Result := True;
  Compress.InStream.LoadFromFile(OpenDialog1.FileName);
  if Compress.InStream.Size <> Compress.OutStream.Size then
    Exit;

  PI := Compress.InStream.Memory;
  PO := Compress.OutStream.Memory;

  Result := True;
  CS := Compress.InStream.Size;
  if CS > 1024 * 128 then
    CS := 1024 * 128; // ȏׂ͒ȂB
  for i := 0 to CS - 1 do
  begin
    if PI[i] <> PO[i] then
    begin
      Result := False;
      Break;
    end;
  end;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
var
  FileName: String;
  Dir: String;
  Rate: String;
begin
  Label4.Caption := SLabel4LZ;
  Label5.Caption := SLabel5LZ;
  Dir := ExtractFilePath(Application.ExeName) + 'Data';

  if OpenDialog1.Execute then
  begin
    SlideDic.InStream.LoadFromFile(OpenDialog1.FileName);
    SlideDic.Encode; // LZ77 ŃGR[hB
    STime := SlideDic.STime;
    RichEdit1.Lines.Text := SlideDic.SHuffmanLen(False);
    RichEdit2.Lines.Text := SlideDic.SHuffmanDist(False);

    Edit1.Text := OpenDialog1.FileName;
    Label1.Caption := '1) Ώۃt@C : ' +
                      IntToStr(SlideDic.InStream.Size) + ' oCg';

    FileName := Dir + '\' + ExtractFileName(OpenDialog1.FileName);
    FileName := ChangeFileExt(FileName,'.enc');
    SlideDic.OutStream.SaveToFile(FileName);

    Rate := Percent(SlideDic.OutStream.Size, SlideDic.InStream.Size);

    Edit2.Text := FileName;
    Label2.Caption := '2) 1) GR[h (  ) t@C : ' +
                      IntToStr(SlideDic.OutStream.Size) +
                      ' oCg ( k : ' + Rate + ' % )';

    SlideDic.InStream.LoadFromFile(FileName);
    SlideDic.Decode;
    STime := Copy(Stime, 1, 5) + ' + ' + SlideDic.STime;

    FileName := ChangeFileExt(FileName,'.dec');
    SlideDic.OutStream.SaveToFile(FileName);

    Edit3.Text := FileName;
    Label3.Caption := '3) 2) fR[h (  ) t@C : ' + IntToStr(SlideDic.OutStream.Size) + ' oCg';

    if CheckSlideDic = True then
      ShowMessage('   GR[hтɃfR[h͐܂B   ' + #13#10 + #13#10 +
                  '   Ώۃt@CƃfR[ht@C͓ełB   ' + #13#10 + #13#10 +
                  '   k ' + Rate + ' % łB   ' + #13#10 + #13#10 +
                  '   GR[h + fR[hԂ ' + STime + '  łB   ')
    else
      ShowMessage('   GR[hyуfR[h͎s܂B   ');
  end;
end;

procedure TFrameForm.Button3Click(Sender: TObject);
var
  FileName: String;
  Dir: String;
  Rate: String;
  S: String;
begin
  Label4.Caption := SLabel4;
  Label5.Caption := SLabel5;
  Dir := ExtractFilePath(Application.ExeName) + 'Data';

  if OpenDialog1.Execute then
  begin
    SlideDic.InStream.LoadFromFile(OpenDialog1.FileName);
    MTime := GetTickCount;
    SlideDic.Encode; // LZ77 ŃGR[hB

    Edit1.Text := OpenDialog1.FileName;
    Label1.Caption := '1) Ώۃt@C : ' +
                      IntToStr(SlideDic.InStream.Size) + ' oCg';

    Huffman.InStream.LoadFromStream(SlideDic.OutStream);
    Huffman.Encode; // Huffman ŃGR[hB
    MTime := GetTickCount - MTime;
    MakeSTime; S := STime;
    RichEdit1.Lines.Text := Huffman.OldNodes;
    RichEdit2.Lines.Text := Huffman.NewNodes;

    FileName := Dir + '\' + ExtractFileName(OpenDialog1.FileName);
    FileName := ChangeFileExt(FileName,'.enc');
    Huffman.OutStream.SaveToFile(FileName);

    Rate := Percent(Huffman.OutStream.Size, SlideDic.InStream.Size);

    Edit2.Text := FileName;
    Label2.Caption := '2) 1) GR[h (  ) t@C : ' +
                      IntToStr(Huffman.OutStream.Size) +
                      ' oCg ( k : ' + Rate + ' % )';

    Huffman.InStream.LoadFromFile(FileName);
    MTime := GetTickCount;
    Huffman.Decode; // Huffman fR[hB

    SlideDic.InStream.LoadFromStream(Huffman.OutStream);
    SlideDic.Decode; // LZ77 fR[hB
    MTime := GetTickCount - MTime;
    MakeSTime; S := Copy(S, 1, 5) + ' + ' + STime;

    FileName := ChangeFileExt(FileName,'.dec');
    SlideDic.OutStream.SaveToFile(FileName);

    Edit3.Text := FileName;
    Label3.Caption := '3) 2) fR[h (  ) t@C : ' + IntToStr(SlideDic.OutStream.Size) + ' oCg';

    if CheckSlideDic = True then
      ShowMessage('   GR[hтɃfR[h͐܂B   ' + #13#10 + #13#10 +
                  '   Ώۃt@CƃfR[ht@C͓ełB   ' + #13#10 + #13#10 +
                  '   k ' + Rate + ' % łB   ' + #13#10 + #13#10 +
                  '   GR[h + fR[hԂ ' + S + '  łB   ')
    else
      ShowMessage('   GR[hyуfR[h͎s܂B   ');
  end;
end;

procedure TFrameForm.Button4Click(Sender: TObject);
var
  FileName: String;
  Dir: String;
  Rate: String;
  S: String;
begin
  Label4.Caption := SLabel4;
  Label5.Caption := SLabel5;
  Dir := ExtractFilePath(Application.ExeName) + 'Data';

  if OpenDialog1.Execute then
  begin
    Huffman.InStream.LoadFromFile(OpenDialog1.FileName);
    MTime := GetTickCount;
    Huffman.Encode; // nt}ŃGR[hB
    RichEdit1.Lines.Text := Huffman.OldNodes;
    RichEdit2.Lines.Text := Huffman.NewNodes;

    Edit1.Text := OpenDialog1.FileName;
    Label1.Caption := '1) Ώۃt@C : ' +
                      IntToStr(Huffman.InStream.Size) + ' oCg';

    SlideDic.InStream.LoadFromStream(Huffman.OutStream);
    SlideDic.Encode; // LZ77 ŃGR[hB
    MTime := GetTickCount - MTime;
    MakeSTime; S := STime;

    FileName := Dir + '\' + ExtractFileName(OpenDialog1.FileName);
    FileName := ChangeFileExt(FileName,'.enc');
    SlideDic.OutStream.SaveToFile(FileName);

    Rate := Percent(SlideDic.OutStream.Size, Huffman.InStream.Size);

    Edit2.Text := FileName;
    Label2.Caption := '2) 1) GR[h (  ) t@C : ' +
                      IntToStr(SlideDic.OutStream.Size) +
                      ' oCg ( k : ' + Rate + ' % )';

    SlideDic.InStream.LoadFromFile(FileName);
    MTime := GetTickCount;
    SlideDic.Decode; // LZ77 fR[hB

    Huffman.InStream.LoadFromStream(SlideDic.OutStream);
    Huffman.Decode; // Huffman fR[hB
    MTime := GetTickCount - MTime;
    MakeSTime; S := Copy(S, 1, 5) + ' + ' + STime;

    FileName := ChangeFileExt(FileName,'.dec');
    Huffman.OutStream.SaveToFile(FileName);

    Edit3.Text := FileName;
    Label3.Caption := '3) 2) fR[h (  ) t@C : ' + IntToStr(Huffman.OutStream.Size) + ' oCg';

    if CheckHuffman = True then
      ShowMessage('   GR[hтɃfR[h͐܂B   ' + #13#10 + #13#10 +
                  '   Ώۃt@CƃfR[ht@C͓ełB   ' + #13#10 + #13#10 +
                  '   k ' + Rate + ' % łB   ' + #13#10 + #13#10 +
                  '   GR[h + fR[hԂ ' + S + '  łB   ')
    else
      ShowMessage('   GR[hyуfR[h͎s܂B   ');
  end;
end;

procedure TFrameForm.Button5Click(Sender: TObject);
var
  FileName: String;
  Dir: String;
  Rate: String;
begin
  Label4.Caption := SLabel4;
  Label5.Caption := SLabel5;
  Dir := ExtractFilePath(Application.ExeName) + 'Data';

  if OpenDialog1.Execute then
  begin
    Compress.InStream.LoadFromFile(OpenDialog1.FileName);
    Compress.Encode; // LZ77 nt}B
    STime := Compress.STime;
    RichEdit1.Lines.Text := Compress.Huffman.OldNodes;
    RichEdit2.Lines.Text := Compress.Huffman.NewNodes;

    Edit1.Text := OpenDialog1.FileName;
    Label1.Caption := '1) Ώۃt@C : ' +
                      IntToStr(Compress.InStream.Size) + ' oCg';

    FileName := Dir + '\' + ExtractFileName(OpenDialog1.FileName);
    FileName := ChangeFileExt(FileName,'.enc');
    Compress.OutStream.SaveToFile(FileName);

    Rate := Percent(Compress.OutStream.Size, Compress.InStream.Size);

    Edit2.Text := FileName;
    Label2.Caption := '2) 1) GR[h (  ) t@C : ' +
                      IntToStr(Compress.OutStream.Size) +
                      ' oCg ( k : ' + Rate + ' % )';

    Compress.InStream.LoadFromFile(FileName);
    Compress.Decode;
    STime := Copy(Stime, 1, 5) + ' + ' + Compress.STime;

    FileName := ChangeFileExt(FileName,'.dec');
    Compress.OutStream.SaveToFile(FileName);

    Edit3.Text := FileName;
    Label3.Caption := '3) 2) fR[h (  ) t@C : ' + IntToStr(Compress.OutStream.Size) + ' oCg';

    if CheckCompress = True then
      ShowMessage('   GR[hтɃfR[h͐܂B   ' + #13#10 + #13#10 +
                  '   Ώۃt@CƃfR[ht@C͓ełB   ' + #13#10 + #13#10 +
                  '   k ' + Rate + ' % łB   ' + #13#10 + #13#10 +
                  '   GR[h + fR[hԂ ' + STime + '  łB   ')
    else
      ShowMessage('   GR[hyуfR[h͎s܂B   ');
  end;
end;

procedure TFrameForm.RadioButton1Click(Sender: TObject);
begin
  SlideDic.DicSize := 1024 * 32; // 1024 ` 1024 * 64
  SlideDic.MatchSize := 256; // 8 ` 256
  SlideDic.LateRating := 0; // 0 ` 3
  SlideDic.Hash := 3;
  Compress.SlideDic.DicSize := 1024 * 32; // 1024 ` 1024 * 64
  Compress.SlideDic.MatchSize := 256; // 8 ` 256
  Compress.SlideDic.LateRating := 0; // 0 ` 3
  Compress.SlideDic.Hash := 3;
  Archiver.Compress.SlideDic.DicSize := 1024 * 32; // 1024 ` 1024 * 64
  Archiver.Compress.SlideDic.MatchSize := 256; // 8 ` 256
  Archiver.Compress.SlideDic.LateRating := 0; // 0 ` 3
  Archiver.Compress.SlideDic.Hash := 3;
end;

procedure TFrameForm.RadioButton2Click(Sender: TObject);
begin
  SlideDic.DicSize := 1024 * 32; // 1024 ` 1024 * 64
  SlideDic.MatchSize := 256; // 8 ` 256
  SlideDic.LateRating := 0; // 0 ` 3
  SlideDic.Hash := 0;
  Compress.SlideDic.DicSize := 1024 * 32; // 1024 ` 1024 * 64
  Compress.SlideDic.MatchSize := 256; // 8 ` 256
  Compress.SlideDic.LateRating := 0; // 0 ` 3
  Compress.SlideDic.Hash := 0;
  Archiver.Compress.SlideDic.DicSize := 1024 * 32; // 1024 ` 1024 * 64
  Archiver.Compress.SlideDic.MatchSize := 256; // 8 ` 256
  Archiver.Compress.SlideDic.LateRating := 0; // 0 ` 3
  Archiver.Compress.SlideDic.Hash := 0;
end;

procedure TFrameForm.RadioButton3Click(Sender: TObject);
begin
  SlideDic.DicSize := 1024 * 64; // 1024 ` 1024 * 64
  SlideDic.MatchSize := 256; // 8 ` 256
  SlideDic.LateRating := 1; // 0 ` 3
  SlideDic.Hash := 0;
  Compress.SlideDic.DicSize := 1024 * 64; // 1024 ` 1024 * 64
  Compress.SlideDic.MatchSize := 256; // 8 ` 256
  Compress.SlideDic.LateRating := 1; // 0 ` 3
  Compress.SlideDic.Hash := 0;
  Archiver.Compress.SlideDic.DicSize := 1024 * 64; // 1024 ` 1024 * 64
  Archiver.Compress.SlideDic.MatchSize := 256; // 8 ` 256
  Archiver.Compress.SlideDic.LateRating := 1; // 0 ` 3
  Archiver.Compress.SlideDic.Hash := 0;
end;

procedure TFrameForm.Button6Click(Sender: TObject);
var
  Dir: String;
  Rate: String;
  n, m: Integer;
begin
  Label4.Caption := SLabel4;
  Label5.Caption := SLabel5;
  Dir := ExtractFilePath(Application.ExeName);
  Archiver.Clear;
  Archiver.PackOption := True;      // fBNg̒ɂɃfBNgĂ̒ɕ
  Archiver.ArcWriteOption := False; // Ƀt@C쐬ɓ̏Ƀt@C͏㏑֎~
  Archiver.ResWriteOption := False; // Ƀt@Cɓ̃t@C͏㏑֎~
  Archiver.ArcDir := '';            // fBtHgl(fXNgbv)
  Archiver.ArcFileName := '';       // fBtHgl(Sample.cps ` Samplex.cps)
  Archiver.ResDir := '';            // fBtHgl(fXNgbv)
  Archiver.PackDir := '';           // fBtHgl(Sample ` Samplex)

  Archiver.ArcTarget.Add(Dir + 'Data\*.txt');
  Archiver.ArcTarget.Add(Dir + 'Data\*.pas');
  Archiver.ArcTarget.Add(Dir + 'Data\Data2');
  n := Archiver.Archive;
  STime := Archiver.STime;
  RichEdit1.Lines.Text := Archiver.Compress.Huffman.OldNodes;
  RichEdit2.Lines.Text := Archiver.Compress.Huffman.NewNodes;

  Archiver.ResTarget := Archiver.ArcDir + '\' + Archiver.ArcFileName;
  m := Archiver.Restore;
  STime := Copy(Stime, 1, 5) + ' + ' + Archiver.STime;

  Rate := Percent(Archiver.ArcSize, Archiver.OrgSize);

  if n = m then
  begin
    ShowMessage('   ' + IntToStr(n) + ' ̃t@C܂ޏɃt@C ' +
      Archiver.ArcFileName + ' fXNgbvɍ쐬   ' + #13#10 + #13#10 +
      '    ' + Archiver.ArcFileName + ' fXNgbṽtH_ ' +
      Archiver.PackDir + ' ɕ܂B' + #13#10 + #13#10 +
      '   k ' + Rate + ' % łB   ' + #13#10 + #13#10 +
      '   ɍ쐬 + Ԃ ' + STime +  ' łB   ');

    Dir := Archiver.ResDir + '\' + Archiver.PackDir;
    ShellExecute(Handle, PChar('open'), PChar(Dir), Nil, Nil, SW_SHOW); // 'explore'
    {
    S := 'Ƀt@C ' + Archiver.ArcFileName + ' Ɋ܂܂t@CƃfBNg' + #13#10 +
       '============================================================' + #13#10;
    for i := 0 to Archiver.Count - 1 do
      S := S + Archiver.FileHeader[i].FileName + #13#10;
    RichEdit1.Lines.Text := S;
    }
  end;
end;

end.

